<?php
/* -----------------------------------------------------------------------------
  Plugin     : Translator.2
  Author     : Grum
    email    : grum@piwigo.org
    website  : http://photos.grum.dnsalias.com

    << May the Little SpaceFrog be with you ! >>
  ------------------------------------------------------------------------------
  See main.inc.php for release information


  --------------------------------------------------------------------------- */
if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

 ini_set('error_reporting', E_ALL);
 ini_set('display_errors', true);

defined('TRANSLATOR_DIR') || define('TRANSLATOR_DIR' , basename(dirname(__FILE__)));
defined('TRANSLATOR_PATH') || define('TRANSLATOR_PATH' , PHPWG_PLUGINS_PATH . TRANSLATOR_DIR . '/');
@include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/tables.class.inc.php');


global $gpc_installed, $lang; //needed for plugin manager compatibility

/* -----------------------------------------------------------------------------
Translator-2 needs the Grum Plugin Classe
----------------------------------------------------------------------------- */
$gpc_installed=false;
if(file_exists(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/common_plugin.class.inc.php'))
{
  @include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/main.inc.php');
  // need GPC release greater or equal than 2.0.1
  if(checkGPCRelease(2,0,1))
  {
    @include_once("translator_install.class.inc.php");
    $gpc_installed=true;
  }
}

function gpcMsgError()
{
  return(sprintf(l10n('g001_gpc2_not_installed'), "2.0.1"));
}
// -----------------------------------------------------------------------------




load_language('plugin.lang', TRANSLATOR_PATH);

function plugin_install($plugin_id, $plugin_version, &$errors) 
{
  global $prefixeTable, $gpc_installed;
  if($gpc_installed)
  {
    $obj = new Translator_install($prefixeTable, __FILE__);
    $result=$obj->install();
    if($result!='')
    {
      $errors=$result;
    }
  }
  else
  {
    gpcMsgError($errors);
  }
}

function plugin_activate($plugin_id, $plugin_version, &$errors)
{
  global $prefixeTable, $gpc_installed;
  
  if($gpc_installed)
  {
    $obj = new Translator_install($prefixeTable, __FILE__);
    $result=$obj->activate();
    if(!$result)
    {
      $errors="";
    }
  }
  else
  {
    gpcMsgError($errors);
  }
}

function plugin_deactivate($plugin_id)
{
}

function plugin_uninstall($plugin_id)
{
  global $prefixeTable, $gpc_installed;

  if($gpc_installed)
  {
    $obj = new Translator_install($prefixeTable, __FILE__);
    $obj->uninstall();
  }
  else
  {
    gpcMsgError($errors);
  }
}


?>
