<?php
/* -----------------------------------------------------------------------------
  Plugin     : Translator
  Author     : Grum
    email    : grum@piwigo.org
    website  : http://photos.grum.dnsalias.com
    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706

    << May the Little SpaceFrog be with you ! >>
  ------------------------------------------------------------------------------
  See main.inc.php for release information

  Translator_install : install classe for plugin

  --------------------------------------------------------------------------- */
  @include_once('translator_root.class.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/tables.class.inc.php');

  /* translator class for install process */
  class Translator_install extends Translator_root
  {
    protected $tablef;

    function Translator_install($prefixeTable, $filelocation)
    {
      parent::__construct($prefixeTable, $filelocation);
      $this->tablef= new manage_tables($this->tables);
    }

    /* 
        function for installation process 
        return true if install process is ok, otherwise false 
    */ 
    function install()
    {
      global $user;

      $tables_def=array(
"CREATE TABLE  `".$this->tables['files']."` (
  `id` int(11) NOT NULL auto_increment,
  `type` enum('piwigo','plugin') NOT NULL default 'piwigo',
  `file` varchar(25) NOT NULL default '',
  `language` varchar(25) NOT NULL default '',
  `version` varchar(10) NOT NULL default '',
  `name` varchar(25) NOT NULL default '',
  `filename` varchar(250) NOT NULL default '',
  `nb_elem` int(11) NOT NULL default '0',
  `nb_ok` int(11) NOT NULL default '0',
  `nb_to_validate` int(11) NOT NULL default '0',
  `nb_to_translate` int(11) NOT NULL default '0',
  `file_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `nb_deleted` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `main_key` (`type`,`file`,`language`,`version`, `name`)
) ENGINE=MyISAM
CHARACTER SET utf8 COLLATE utf8_general_ci;",

"CREATE TABLE  `".$this->tables['keys']."` (
  `id` varbinary(250) NOT NULL default '',
  `file_id` int(11) NOT NULL default '0',
  `version` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `translator` int(11) NOT NULL default '2',
  `status` enum('ok','valide_it','not_translated', 'deleted') NOT NULL default 'not_translated',
  `translation` text NOT NULL,
  `validate_by` int(11) NOT NULL default '0',
  `validate_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `uniqueindex` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`,`file_id`,`version`),
  KEY `unique_index` (`uniqueindex`)
) ENGINE=MyISAM
CHARACTER SET utf8 COLLATE utf8_general_ci;",

"CREATE TABLE  `".$this->tables['langs']."` (
  `lang_code` char(2) NOT NULL default '',
  `country_code` char(2) NOT NULL default '',
  `direction` enum('ltr','rtl') NOT NULL default 'ltr',
  `name` varchar(25) NOT NULL default '',
  `country` varchar(25) NOT NULL default '',
  `zero_plural` char(1) NOT NULL default 'n',
  `code` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`lang_code`,`country_code`)
) ENGINE=MyISAM
CHARACTER SET utf8 COLLATE utf8_general_ci;",

"CREATE TABLE  `".$this->tables['langs_codes']."` (
  `code` char(2) NOT NULL default '',
  `name` varchar(25) NOT NULL default '',
  `familly` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`code`)
) ENGINE=MyISAM
CHARACTER SET utf8 COLLATE utf8_general_ci;",

"CREATE TABLE  `".$this->tables['countries_codes']."` (
  `code` char(2) NOT NULL default '',
  `name` varchar(25) NOT NULL default '',
  PRIMARY KEY  (`code`)
) ENGINE=MyISAM
CHARACTER SET utf8 COLLATE utf8_general_ci;",

"CREATE TABLE `".$this->tables['users']."` (
  `id` smallint(6) NOT NULL default '0',
  `country` varchar(2) NOT NULL default '',
  `town` varchar(25) NOT NULL default '',
  `native_language` varchar(2) NOT NULL default '',
  `sex` char(1) NOT NULL default '',
  `birthdate` date default NULL,
  `comment` text,
  `display_spoken_lang` char(1) NOT NULL default 'y',
  `default_displayed_language` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM 
CHARACTER SET utf8 COLLATE utf8_general_ci;",

"CREATE TABLE `".$this->tables['users_langs']."` (
  `id` SMALLINT  NOT NULL,
  `lang` CHAR(2)  NOT NULL,
  PRIMARY KEY (`id`, `lang`)
) ENGINE = MyISAM
CHARACTER SET utf8 COLLATE utf8_general_ci;",
      );
      //$table_def array

      $this->init_config();

      $result=$this->modify_functions_file();
      if($result=="")
      {
        $result=$this->tablef->create_tables($tables_def);
        if($result)
        {
          $this->load_langs_code();
          $this->load_country_code();
          $files=$this->search_languages_files();
          foreach($files as $key=>$file)
          {
            $files[$key]=$this->analyze_filename($file);
          }
          $errors=$this->load_lang_files('', $files, $user['user_id']);
          //return(print_r($errors, true));
          return($errors);
        }
      }
      return($result);
    }


    /*
        function for uninstall process
    */
    function uninstall()
    {
      $error="";
      $error.=$this->delete_config();
      $error.=$this->tablef->drop_tables();
      $error.=$this->restore_functions_user_file();
      return($error);
    }

    function activate()
    {
      $this->init_config();
      $this->load_config();
      $this->save_config();
    }

    function deactivate()
    {
    }

    function load_country_code()
    {
      // ISO 3166 CODES ALPHABETIC COUNTRY NAME (ENGLISH SPELLING)
      // http://www.iso.ch/iso/country_codes/iso_3166_code_lists/english_country_names_and_code_elements.htm
      $countries_codes=array(
        array('AFGHANISTAN', 'AF'),
        array('ÅLAND ISLANDS', 'AX'),
        array('ALBANIA', 'AL'),
        array('ALGERIA', 'DZ'),
        array('AMERICAN SAMOA', 'AS'),
        array('ANDORRA', 'AD'),
        array('ANGOLA', 'AO'),
        array('ANGUILLA', 'AI'),
        array('ANTARCTICA', 'AQ'),
        array('ANTIGUA AND BARBUDA', 'AG'),
        array('ARGENTINA', 'AR'),
        array('ARMENIA', 'AM'),
        array('ARUBA', 'AW'),
        array('AUSTRALIA', 'AU'),
        array('AUSTRIA', 'AT'),
        array('AZERBAIJAN', 'AZ'),
        array('BAHAMAS', 'BS'),
        array('BAHRAIN', 'BH'),
        array('BANGLADESH', 'BD'),
        array('BARBADOS', 'BB'),
        array('BELARUS', 'BY'),
        array('BELGIUM', 'BE'),
        array('BELIZE', 'BZ'),
        array('BENIN', 'BJ'),
        array('BERMUDA', 'BM'),
        array('BHUTAN', 'BT'),
        array('BOLIVIA', 'BO'),
        array('BOSNIA AND HERZEGOVINA', 'BA'),
        array('BOTSWANA', 'BW'),
        array('BOUVET ISLAND', 'BV'),
        array('BRAZIL', 'BR'),
        array('BRITISH INDIAN OCEAN TERRITORY', 'IO'),
        array('BRUNEI DARUSSALAM', 'BN'),
        array('BULGARIA', 'BG'),
        array('BURKINA FASO', 'BF'),
        array('BURUNDI', 'BI'),
        array('CAMBODIA', 'KH'),
        array('CAMEROON', 'CM'),
        array('CANADA', 'CA'),
        array('CAPE VERDE', 'CV'),
        array('CAYMAN ISLANDS', 'KY'),
        array('CENTRAL AFRICAN REPUBLIC', 'CF'),
        array('CHAD', 'TD'),
        array('CHILE', 'CL'),
        array('CHINA', 'CN'),
        array('CHRISTMAS ISLAND', 'CX'),
        array('COCOS (KEELING) ISLANDS', 'CC'),
        array('COLOMBIA', 'CO'),
        array('COMOROS', 'KM'),
        array('CONGO', 'CG'),
        array('CONGO, THE DEMOCRATIC REPUBLIC OF THE', 'CD'),
        array('COOK ISLANDS', 'CK'),
        array('COSTA RICA', 'CR'),
        array('CÔTE D\'IVOIRE', 'CI'),
        array('CROATIA', 'HR'),
        array('CUBA', 'CU'),
        array('CYPRUS', 'CY'),
        array('CZECH REPUBLIC', 'CZ'),
        array('DENMARK', 'DK'),
        array('DJIBOUTI', 'DJ'),
        array('DOMINICA', 'DM'),
        array('DOMINICAN REPUBLIC', 'DO'),
        array('ECUADOR', 'EC'),
        array('EGYPT', 'EG'),
        array('EL SALVADOR', 'SV'),
        array('EQUATORIAL GUINEA', 'GQ'),
        array('ERITREA', 'ER'),
        array('ESTONIA', 'EE'),
        array('ETHIOPIA', 'ET'),
        array('FALKLAND ISLANDS (MALVINAS)', 'FK'),
        array('FAROE ISLANDS', 'FO'),
        array('FIJI', 'FJ'),
        array('FINLAND', 'FI'),
        array('FRANCE', 'FR'),
        array('FRENCH GUIANA', 'GF'),
        array('FRENCH POLYNESIA', 'PF'),
        array('FRENCH SOUTHERN TERRITORIES', 'TF'),
        array('GABON', 'GA'),
        array('GAMBIA', 'GM'),
        array('GEORGIA', 'GE'),
        array('GERMANY', 'DE'),
        array('GHANA', 'GH'),
        array('GIBRALTAR', 'GI'),
        array('GREECE', 'GR'),
        array('GREENLAND', 'GL'),
        array('GRENADA', 'GD'),
        array('GUADELOUPE', 'GP'),
        array('GUAM', 'GU'),
        array('GUATEMALA', 'GT'),
        array('GUERNSEY', 'GG'),
        array('GUINEA', 'GN'),
        array('GUINEA-BISSAU', 'GW'),
        array('GUYANA', 'GY'),
        array('HAITI', 'HT'),
        array('HEARD ISLAND AND MCDONALD ISLANDS', 'HM'),
        array('HOLY SEE (VATICAN CITY STATE)', 'VA'),
        array('HONDURAS', 'HN'),
        array('HONG KONG', 'HK'),
        array('HUNGARY', 'HU'),
        array('ICELAND', 'IS'),
        array('INDIA', 'IN'),
        array('INDONESIA', 'ID'),
        array('IRAN, ISLAMIC REPUBLIC OF', 'IR'),
        array('IRAQ', 'IQ'),
        array('IRELAND', 'IE'),
        array('ISLE OF MAN', 'IM'),
        array('ISRAEL', 'IL'),
        array('ITALY', 'IT'),
        array('JAMAICA', 'JM'),
        array('JAPAN', 'JP'),
        array('JERSEY', 'JE'),
        array('JORDAN', 'JO'),
        array('KAZAKHSTAN', 'KZ'),
        array('KENYA', 'KE'),
        array('KIRIBATI', 'KI'),
        array('KOREA, DEMOCRATIC PEOPLE\'S REPUBLIC OF', 'KP'),
        array('KOREA, REPUBLIC OF', 'KR'),
        array('KUWAIT', 'KW'),
        array('KYRGYZSTAN', 'KG'),
        array('LAO PEOPLE\'S DEMOCRATIC REPUBLIC', 'LA'),
        array('LATVIA', 'LV'),
        array('LEBANON', 'LB'),
        array('LESOTHO', 'LS'),
        array('LIBERIA', 'LR'),
        array('LIBYAN ARAB JAMAHIRIYA', 'LY'),
        array('LIECHTENSTEIN', 'LI'),
        array('LITHUANIA', 'LT'),
        array('LUXEMBOURG', 'LU'),
        array('MACAO', 'MO'),
        array('MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF', 'MK'),
        array('MADAGASCAR', 'MG'),
        array('MALAWI', 'MW'),
        array('MALAYSIA', 'MY'),
        array('MALDIVES', 'MV'),
        array('MALI', 'ML'),
        array('MALTA', 'MT'),
        array('MARSHALL ISLANDS', 'MH'),
        array('MARTINIQUE', 'MQ'),
        array('MAURITANIA', 'MR'),
        array('MAURITIUS', 'MU'),
        array('MAYOTTE', 'YT'),
        array('MEXICO', 'MX'),
        array('MICRONESIA, FEDERATED STATES OF', 'FM'),
        array('MOLDOVA', 'MD'),
        array('MONACO', 'MC'),
        array('MONGOLIA', 'MN'),
        array('MONTENEGRO', 'ME'),
        array('MONTSERRAT', 'MS'),
        array('MOROCCO', 'MA'),
        array('MOZAMBIQUE', 'MZ'),
        array('MYANMAR', 'MM'),
        array('NAMIBIA', 'NA'),
        array('NAURU', 'NR'),
        array('NEPAL', 'NP'),
        array('NETHERLANDS', 'NL'),
        array('NETHERLANDS ANTILLES', 'AN'),
        array('NEW CALEDONIA', 'NC'),
        array('NEW ZEALAND', 'NZ'),
        array('NICARAGUA', 'NI'),
        array('NIGER', 'NE'),
        array('NIGERIA', 'NG'),
        array('NIUE', 'NU'),
        array('NORFOLK ISLAND', 'NF'),
        array('NORTHERN MARIANA ISLANDS', 'MP'),
        array('NORWAY', 'NO'),
        array('OMAN', 'OM'),
        array('PAKISTAN', 'PK'),
        array('PALAU', 'PW'),
        array('PALESTINIAN TERRITORY, OCCUPIED', 'PS'),
        array('PANAMA', 'PA'),
        array('PAPUA NEW GUINEA', 'PG'),
        array('PARAGUAY', 'PY'),
        array('PERU', 'PE'),
        array('PHILIPPINES', 'PH'),
        array('PITCAIRN', 'PN'),
        array('POLAND', 'PL'),
        array('PORTUGAL', 'PT'),
        array('PUERTO RICO', 'PR'),
        array('QATAR', 'QA'),
        array('RÉUNION', 'RE'),
        array('ROMANIA', 'RO'),
        array('RUSSIAN FEDERATION', 'RU'),
        array('RWANDA', 'RW'),
        array('SAINT BARTHÉLEMY','BL'),
        array('SAINT HELENA', 'SH'),
        array('SAINT KITTS AND NEVIS', 'KN'),
        array('SAINT LUCIA', 'LC'),
        array('SAINT MARTIN', 'MF'),
        array('SAINT PIERRE AND MIQUELON', 'PM'),
        array('SAINT VINCENT AND THE GRENADINES', 'VC'),
        array('SAMOA', 'WS'),
        array('SAN MARINO', 'SM'),
        array('SAO TOME AND PRINCIPE', 'ST'),
        array('SAUDI ARABIA', 'SA'),
        array('SENEGAL', 'SN'),
        array('SERBIA', 'RS'),
        array('SEYCHELLES', 'SC'),
        array('SIERRA LEONE', 'SL'),
        array('SINGAPORE', 'SG'),
        array('SLOVAKIA', 'SK'),
        array('SLOVENIA', 'SI'),
        array('SOLOMON ISLANDS', 'SB'),
        array('SOMALIA', 'SO'),
        array('SOUTH AFRICA', 'ZA'),
        array('SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS', 'GS'),
        array('SPAIN', 'ES'),
        array('SRI LANKA', 'LK'),
        array('SUDAN', 'SD'),
        array('SURINAME', 'SR'),
        array('SVALBARD AND JAN MAYEN', 'SJ'),
        array('SWAZILAND', 'SZ'),
        array('SWEDEN', 'SE'),
        array('SWITZERLAND', 'CH'),
        array('SYRIAN ARAB REPUBLIC', 'SY'),
        array('TAIWAN, PROVINCE OF CHINA', 'TW'),
        array('TAJIKISTAN', 'TJ'),
        array('TANZANIA, UNITED REPUBLIC OF','TZ'),
        array('THAILAND', 'TH'),
        array('TIMOR-LESTE', 'TL'),
        array('TOGO', 'TG'),
        array('TOKELAU', 'TK'),
        array('TONGA', 'TO'),
        array('TRINIDAD AND TOBAGO', 'TT'),
        array('TUNISIA', 'TN'),
        array('TURKEY', 'TR'),
        array('TURKMENISTAN', 'TM'),
        array('TURKS AND CAICOS ISLANDS', 'TC'),
        array('TUVALU', 'TV'),
        array('UGANDA', 'UG'),
        array('UKRAINE', 'UA'),
        array('UNITED ARAB EMIRATES', 'AE'),
        array('UNITED KINGDOM', 'GB'),
        array('UNITED STATES', 'US'),
        array('UNITED STATES MINOR OUTLYING ISLANDS', 'UM'),
        array('URUGUAY', 'UY'),
        array('UZBEKISTAN', 'UZ'),
        array('VANUATU', 'VU'),
        array('VENEZUELA', 'VE'),
        array('VIET NAM', 'VN'),
        array('VIRGIN ISLANDS, BRITISH', 'VG'),
        array('VIRGIN ISLANDS, U.S.', 'VI'),
        array('WALLIS AND FUTUNA', 'WF'),
        array('WESTERN SAHARA', 'EH'),
        array('YEMEN', 'YE'),
        array('ZAMBIA', 'ZM'),
        array('ZIMBABWE', 'ZW'),
      );

      foreach($countries_codes as $val)
      {
        $sql="INSERT INTO ".$this->tables['countries_codes']." VALUES(
          '".$val[1]."',
          '".htmlspecialchars($val[0], ENT_QUOTES)."'
        )";
        $result=pwg_query($sql);
      }
    }

    function load_langs_code()
    {
      // ISO 639 CODES ALPHABETIC LANGUAGE NAME (ENGLISH SPELLING)
      // http://xml.coverpages.org/iso639a.html
      $langs_code=array(
        array('AYMARA', 'AY', 'AMERINDIAN'),
        array('GUARANI', 'GN', 'AMERINDIAN'),
        array('QUECHUA', 'QU', 'AMERINDIAN'),
        array('BHUTANI', 'DZ', 'ASIAN'),
        array('BURMESE', 'MY', 'ASIAN'),
        array('CAMBODIAN', 'KM', 'ASIAN'),
        array('CHINESE', 'ZH', 'ASIAN'),
        array('JAPANESE', 'JA', 'ASIAN'),
        array('KOREAN', 'KO', 'ASIAN'),
        array('LAOTHIAN', 'LO', 'ASIAN'),
        array('THAI', 'TH', 'ASIAN'),
        array('TIBETAN', 'BO', 'ASIAN'),
        array('VIETNAMESE', 'VI', 'ASIAN'),
        array('LATVIAN;LETTISH', 'LV', 'BALTIC'),
        array('LITHUANIAN', 'LT', 'BALTIC'),
        array('BASQUE', 'EU', 'BASQUE'),
        array('BRETON', 'BR', 'CELTIC'),
        array('IRISH', 'GA', 'CELTIC'),
        array('SCOTS GAELIC', 'GD', 'CELTIC'),
        array('WELSH', 'CY', 'CELTIC'),
        array('KANNADA', 'KN', 'DRAVIDIAN'),
        array('MALAYALAM', 'ML', 'DRAVIDIAN'),
        array('TAMIL', 'TA', 'DRAVIDIAN'),
        array('TELUGU', 'TE', 'DRAVIDIAN'),
        array('GREENLANDIC', 'KL', 'ESKIMO'),
        array('INUPIAK', 'IK', 'ESKIMO'),
        array('ESTONIAN', 'ET', 'FINNO-UGRIC'),
        array('FINNISH', 'FI', 'FINNO-UGRIC'),
        array('HUNGARIAN', 'HU', 'FINNO-UGRIC'),
        array('AFRIKAANS', 'AF', 'GERMANIC'),
        array('DANISH', 'DA', 'GERMANIC'),
        array('DUTCH', 'NL', 'GERMANIC'),
        array('ENGLISH', 'EN', 'GERMANIC'),
        array('FAROESE', 'FO', 'GERMANIC'),
        array('FRISIAN', 'FY', 'GERMANIC'),
        array('GERMAN', 'DE', 'GERMANIC'),
        array('ICELANDIC', 'IS', 'GERMANIC'),
        array('NORWEGIAN', 'NO', 'GERMANIC'),
        array('SWEDISH', 'SV', 'GERMANIC'),
        array('YIDDISH', 'YI', 'GERMANIC'),
        array('AFAN (OROMO)', 'OM', 'HAMITIC'),
        array('AFAR', 'AA', 'HAMITIC'),
        array('SOMALI', 'SO', 'HAMITIC'),
        array('ABKHAZIAN', 'AB', 'IBERO-CAUCASIAN'),
        array('GEORGIAN', 'KA', 'IBERO-CAUCASIAN'),
        array('ASSAMESE', 'AS', 'INDIAN'),
        array('BENGALI;BANGLA', 'BN', 'INDIAN'),
        array('BIHARI', 'BH', 'INDIAN'),
        array('GUJARATI', 'GU', 'INDIAN'),
        array('HINDI', 'HI', 'INDIAN'),
        array('KASHMIRI', 'KS', 'INDIAN'),
        array('MARATHI', 'MR', 'INDIAN'),
        array('NEPALI', 'NE', 'INDIAN'),
        array('ORIYA', 'OR', 'INDIAN'),
        array('PUNJABI', 'PA', 'INDIAN'),
        array('SANSKRIT', 'SA', 'INDIAN'),
        array('SINDHI', 'SD', 'INDIAN'),
        array('SINGHALESE', 'SI', 'INDIAN'),
        array('URDU', 'UR', 'INDIAN'),
        array('ALBANIAN', 'SQ', 'INDO-EUROPEAN (OTHER)'),
        array('ARMENIAN', 'HY', 'INDO-EUROPEAN (OTHER)'),
        array('ESPERANTO', 'EO', 'INTERNATIONAL AUX.'),
        array('INTERLINGUA', 'IA', 'INTERNATIONAL AUX.'),
        array('INTERLINGUE', 'IE', 'INTERNATIONAL AUX.'),
        array('VOLAPUK', 'VO', 'INTERNATIONAL AUX.'),
        array('KURDISH', 'KU', 'IRANIAN'),
        array('PASHTO;PUSHTO', 'PS', 'IRANIAN'),
        array('PERSIAN (farsi)', 'FA', 'IRANIAN'),
        array('TAJIK', 'TG', 'IRANIAN'),
        array('GREEK', 'EL', 'LATIN/GREEK'),
        array('LATIN', 'LA', 'LATIN/GREEK'),
        array('HAUSA', 'HA', 'NEGRO-AFRICAN'),
        array('KINYARWANDA', 'RW', 'NEGRO-AFRICAN'),
        array('KURUNDI', 'RN', 'NEGRO-AFRICAN'),
        array('LINGALA', 'LN', 'NEGRO-AFRICAN'),
        array('SANGHO', 'SG', 'NEGRO-AFRICAN'),
        array('SESOTHO', 'ST', 'NEGRO-AFRICAN'),
        array('SETSWANA', 'TN', 'NEGRO-AFRICAN'),
        array('SHONA', 'SN', 'NEGRO-AFRICAN'),
        array('SISWATI', 'SS', 'NEGRO-AFRICAN'),
        array('SWAHILI', 'SW', 'NEGRO-AFRICAN'),
        array('TSONGA', 'TS', 'NEGRO-AFRICAN'),
        array('TWI', 'TW', 'NEGRO-AFRICAN'),
        array('WOLOF', 'WO', 'NEGRO-AFRICAN'),
        array('XHOSA', 'XH', 'NEGRO-AFRICAN'),
        array('YORUBA', 'YO', 'NEGRO-AFRICAN'),
        array('ZULU', 'ZU', 'NEGRO-AFRICAN'),
        array('FIJI', 'FJ', 'OCEANIC/INDONESIAN'),
        array('INDONESIAN', 'ID', 'OCEANIC/INDONESIAN'),
        array('JAVANESE', 'JV', 'OCEANIC/INDONESIAN'),
        array('MALAGASY', 'MG', 'OCEANIC/INDONESIAN'),
        array('MALAY', 'MS', 'OCEANIC/INDONESIAN'),
        array('MAORI', 'MI', 'OCEANIC/INDONESIAN'),
        array('SAMOAN', 'SM', 'OCEANIC/INDONESIAN'),
        array('SUNDANESE', 'SU', 'OCEANIC/INDONESIAN'),
        array('TAGALOG', 'TL', 'OCEANIC/INDONESIAN'),
        array('TONGA', 'TO', 'OCEANIC/INDONESIAN'),
        array('CATALAN', 'CA', 'ROMANCE'),
        array('CORSICAN', 'CO', 'ROMANCE'),
        array('FRENCH', 'FR', 'ROMANCE'),
        array('GALICIAN', 'GL', 'ROMANCE'),
        array('ITALIAN', 'IT', 'ROMANCE'),
        array('MOLDAVIAN', 'MO', 'ROMANCE'),
        array('OCCITAN', 'OC', 'ROMANCE'),
        array('PORTUGUESE', 'PT', 'ROMANCE'),
        array('RHAETO-ROMANCE', 'RM', 'ROMANCE'),
        array('ROMANIAN', 'RO', 'ROMANCE'),
        array('SPANISH', 'ES', 'ROMANCE'),
        array('AMHARIC', 'AM', 'SEMITIC'),
        array('ARABIC', 'AR', 'SEMITIC'),
        array('HEBREW', 'HE', 'SEMITIC'),
        array('MALTESE', 'MT', 'SEMITIC'),
        array('TIGRINYA', 'TI', 'SEMITIC'),
        array('BULGARIAN', 'BG', 'SLAVIC'),
        array('BYELORUSSIAN', 'BE', 'SLAVIC'),
        array('CROATIAN', 'HR', 'SLAVIC'),
        array('CZECH', 'CS', 'SLAVIC'),
        array('MACEDONIAN', 'MK', 'SLAVIC'),
        array('POLISH', 'PL', 'SLAVIC'),
        array('RUSSIAN', 'RU', 'SLAVIC'),
        array('SERBIAN', 'SR', 'SLAVIC'),
        array('SERBO-CROATIAN', 'SH', 'SLAVIC'),
        array('SLOVAK', 'SK', 'SLAVIC'),
        array('SLOVENIAN', 'SL', 'SLAVIC'),
        array('UKRAINIAN', 'UK', 'SLAVIC'),
        array('AZERBAIJANI', 'AZ', 'TURKIC/ALTAIC'),
        array('BASHKIR', 'BA', 'TURKIC/ALTAIC'),
        array('KAZAKH', 'KK', 'TURKIC/ALTAIC'),
        array('KIRGHIZ', 'KY', 'TURKIC/ALTAIC'),
        array('TATAR', 'TT', 'TURKIC/ALTAIC'),
        array('TURKISH', 'TR', 'TURKIC/ALTAIC'),
        array('TURKMEN', 'TK', 'TURKIC/ALTAIC'),
        array('UZBEK', 'UZ', 'TURKIC/ALTAIC'),
        array('BISLAMA', 'BI', '[not given]'),
        array('MONGOLIAN', 'MN', '[not given]'),
        array('NAURU', 'NA', '[not given]')
      );

      foreach($langs_code as $val)
      {
        $sql="INSERT INTO ".$this->tables['langs_codes']." VALUES(
          '".$val[1]."',
          '".$val[0]."',
          '".$val[2]."'
        )";
        $result=pwg_query($sql);
      }
    }

    
    /* this function modify the get_language_filepath inside the
          include/functions_user.inc.php file by replacing a portion of code
        the modifiction consist to return a translator_xx.lang.php language file replacing
        a xx.lang.php file when user is in "translator_mode"

        original pwg file is backup to include/functions_user.inc.php.translator-backup file

        returns "" if sucess, otherwise returns an error message
    */
    function modify_functions_file()
    {
      $functions_file=PHPWG_ROOT_PATH."include/functions.inc.php";

      if(PHPWG_VERSION == "2.0.0")
      {
        if(copy($functions_file, $functions_file.".translator-backup"))
        {
          $fhandle=fopen($functions_file, "r");
          if($fhandle)
          {
            $body=fread($fhandle, filesize($functions_file));
            fclose($fhandle);

            $search_code = '/[\r\s]*if[\r\s]*\(file_exists\(\$filepath\)\)[\r\s]*\{[\r\s]*return[\r\s]*\$filepath;[\r\s]*\}[\r\s]*/';

            $search_code = '/[\r\s]*if[\r\s]*\([\r\s]*![\r\s]*empty\(\$source_file\)[\r\s]*\)[\r\s]*\{[\r\s]*if[\r\s]*\([\r\s]*![\r\s]*@\$options\[\'return\'\][\r\s]*\)[\r\s]*\{/';

            $new_code = '
if ( !empty($source_file) )
  {
  /* >>> translator >>> */
  if(isset($user[\'translator_mode\'])&&($user[\'translator_mode\']==\'yes\')&&(file_exists($source_file.".t")))
  {
    $source_file.=".t";
  }
  /* <<< translator <<< */
    if (! @$options[\'return\'] )
    {
'; //new code


            $body=preg_replace($search_code, $new_code, $body);

            $fhandle=fopen($functions_file, "w");
            if($fhandle)
            {
              fwrite($fhandle, $body);
              fclose($fhandle);
              return("");
            }
          }
          return(l10n('g001_error_modify_translator'));
        }
        return(l10n('g001_error_copy_backup'));
      }
      return(l10n('g001_error_pwg_version'));
    }

    /*
      this function restore the original include/functions_user.inc.php file
      who is backuped to include/functions_user.inc.php.translator-backup file

      returns "" if sucess, otherwise returns an error message
    */
    function restore_functions_user_file()
    {
      $functions_file=PHPWG_ROOT_PATH."include/functions.inc.php";
      if(copy($functions_file.".translator-backup", $functions_file))
      {
        unlink($functions_file.".translator-backup");
        return("");
      }
      return(l10n('g001_error_restore_backup'));
    }

  } //class

?>
